#    Inside The Data Tunnel - My game for PyWeek 20.
#    Copyright (C) 2015  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

import pygame

from config import config
from classes.Menu_Item import Menu_Item
from classes.Text import Text

pygame.init()


class Menu( object ):
	"""
	"""
	def __init__( self, _menu_data ):
		"""
		"""
		self.menu_heading = pygame.sprite.GroupSingle()
		if _menu_data.has_key( "heading" ):
			self.menu_heading.add( Text( **_menu_data["heading"] ) )
		
		self.menu_items = pygame.sprite.Group()
		for menu_item in _menu_data["menu_items"].itervalues():
			self.menu_items.add( Menu_Item( menu_item ) )

		self.current_index = 1
		self.min_index = 1
		self.max_index = len( self.menu_items )

		self.action = ""


	def update( self, _eventlist ):
		"""

		"""
		for event in _eventlist:
			if event.type == pygame.KEYDOWN:
				if event.key == pygame.K_UP and self.current_index > 1:
					self.current_index -= 1
				elif event.key == pygame.K_DOWN and self.current_index < self.max_index:
					self.current_index += 1

		for x in self.menu_items:
			x.update_status( self.current_index )

		for x in self.menu_items:
			if x.update( _eventlist, self.current_index ):
				self.action = x.action


	def draw( self, _window ):
		self.menu_heading.draw( _window )
		self.menu_items.draw( _window )


	def reset( self ):
		"""

		"""
		self.action = ""
		self.current_index = 1
