#    Inside The Data Tunnel - My game for PyWeek 20.
#    Copyright (C) 2015  Jannik Haberbosch
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


# Modules
# Standard Python modules
import random

# Third party modules
import pygame

# Own modules
from config import config
from classes.Active_Moving_Sprite import Active_Moving_Sprite


class Player1( Active_Moving_Sprite ):
	def __init__( self, _image, _pos_center, _direction, _speed, _turn_speed,
				  _allowed_area, _max_hitpoints, _current_hitpoints,
				  _projectile_speed, _projectile_image, _projectile_damage,
				  _controls ):
				  
		super( Player1, self ).__init__( _image, _pos_center, _direction, _speed,
										_turn_speed, _allowed_area,
										_max_hitpoints, _current_hitpoints,
				  						_projectile_speed, _projectile_image,
				  						_projectile_damage )

		self.controls = _controls


	def update( self, _eventlist ):
		"""

		"""
		for event in _eventlist:
			if event.type == pygame.KEYDOWN:
				if event.key == pygame.K_UP:
					self.controls[pygame.K_UP] = True
				if event.key == pygame.K_DOWN:
					self.controls[pygame.K_DOWN] = True
				if event.key == pygame.K_LEFT:
					self.controls[pygame.K_LEFT] = True
				if event.key == pygame.K_RIGHT:
					self.controls[pygame.K_RIGHT] = True
				if event.key == pygame.K_RCTRL:
					self.controls[pygame.K_RCTRL] = True									

			if event.type == pygame.KEYUP:
				if event.key == pygame.K_UP:
					self.controls[pygame.K_UP] = False
				if event.key == pygame.K_DOWN:
					self.controls[pygame.K_DOWN] = False
				if event.key == pygame.K_LEFT:
					self.controls[pygame.K_LEFT] = False
				if event.key == pygame.K_RIGHT:
					self.controls[pygame.K_RIGHT] = False					


		if self.controls[pygame.K_UP]:
			self.rect.centery -= self.get_speed()

		if self.controls[pygame.K_DOWN]:
			self.rect.centery += self.get_speed()

		if self.controls[pygame.K_LEFT]:
			self.rect.centerx -= self.get_speed()

		if self.controls[pygame.K_RIGHT]:
			self.rect.centerx += self.get_speed()

		if self.controls[pygame.K_RCTRL]:
			self.fire_projectile()
			self.controls[pygame.K_RCTRL] = False

		if len( self.projectiles ) > 0:
			self.projectiles.update()				
